"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.invalidEnumField = exports.noSuperClassForVariant = exports.extendedReaderNotFound = exports.extendedWriterNotFound = exports.unexpectedFieldSchema = exports.invalidByteArrayLength = void 0;
function invalidByteArrayLength(path, expected, actual) {
    throw new Error(`Borsh: Invalid byte array length at: ${path.join(',')}, expected: ${expected}, actual: ${actual}`);
}
exports.invalidByteArrayLength = invalidByteArrayLength;
function unexpectedFieldSchema(path, expected, actual) {
    throw new Error(`Borsh: Found an unexpected schema at: ${path.join(',')}, expected: ${expected}, actual: ${actual}`);
}
exports.unexpectedFieldSchema = unexpectedFieldSchema;
function extendedWriterNotFound(path) {
    throw new Error(`Borsh: Extended writer not found at: ${path.join(',')}`);
}
exports.extendedWriterNotFound = extendedWriterNotFound;
function extendedReaderNotFound(path) {
    throw new Error(`Borsh: Extended reader not found at: ${path.join(',')}`);
}
exports.extendedReaderNotFound = extendedReaderNotFound;
function noSuperClassForVariant(cls) {
    throw new Error(`Borsh: No super class available for class ${cls} which is decorated as variant`);
}
exports.noSuperClassForVariant = noSuperClassForVariant;
function invalidEnumField(path) {
    throw new Error(`Borsh: Invalid enum field type at: ${path.join(',')}`);
}
exports.invalidEnumField = invalidEnumField;
//# sourceMappingURL=errors.js.map