import { HasExtendedWriter, IExtendWriter } from './types';
export interface IWrite {
    length: number;
    write(buf: Uint8Array, offset: number): void;
}
export declare function writeU8(value: number, buf: Uint8Array, offset?: number): number;
export declare function writeU16(value: number, buf: Uint8Array, offset?: number): number;
export declare function writeU32(value: number, buf: Uint8Array, offset?: number): number;
export declare function writeU64(value: bigint, buf: Uint8Array, offset?: number): number;
export declare class WriteBool implements IWrite {
    #private;
    constructor(value: boolean);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteU8 implements IWrite {
    #private;
    constructor(value: number);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteU16 implements IWrite {
    #private;
    constructor(value: number);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteU32 implements IWrite {
    #private;
    constructor(value: number);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteU64 implements IWrite {
    #private;
    constructor(value: bigint);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteUint8Array implements IWrite {
    #private;
    constructor(value: Uint8Array);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteString {
    #private;
    constructor(value: string);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class WriteExtended<T> {
    #private;
    constructor(value: T, size: number, writer: IExtendWriter<T>);
    get length(): number;
    write(buf: Uint8Array, offset?: number): void;
}
export declare class BinaryWriter {
    #private;
    constructor();
    writeBool(value: boolean): void;
    writeU8(value: number): void;
    writeU16(value: number): void;
    writeU32(value: number): void;
    writeU64(value: bigint): void;
    writeU128(): void;
    writeI8(): void;
    writeI16(): void;
    writeI32(): void;
    writeI64(): void;
    writeI128(): void;
    writeString(value: string): void;
    writeByteArray(value: Uint8Array): void;
    writeF32(): void;
    writeF64(): void;
    writeExtended<T>(value: T, options: HasExtendedWriter<T>): void;
    toArray(): Uint8Array;
}
