"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _WriteBool_value, _WriteU8_value, _WriteU16_value, _WriteU32_value, _WriteU64_value, _WriteUint8Array_value, _WriteString_value, _WriteString_length, _WriteExtended_value, _WriteExtended_length, _WriteExtended_writer, _BinaryWriter_writes, _BinaryWriter_length;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryWriter = exports.WriteExtended = exports.WriteString = exports.WriteUint8Array = exports.WriteU64 = exports.WriteU32 = exports.WriteU16 = exports.WriteU8 = exports.WriteBool = exports.writeU64 = exports.writeU32 = exports.writeU16 = exports.writeU8 = void 0;
const textEncoder = new TextEncoder();
function writeU8(value, buf, offset = 0) {
    buf.set([value], offset);
    return offset + 1;
}
exports.writeU8 = writeU8;
function writeU16(value, buf, offset = 0) {
    buf.set([value & 0xff, (value >> 8) & 0xff], offset);
    return offset + 2;
}
exports.writeU16 = writeU16;
function writeU32(value, buf, offset = 0) {
    buf.set([value & 0xff, (value >> 8) & 0xff, (value >> 16) & 0xff, (value >> 24) & 0xff], offset);
    return offset + 4;
}
exports.writeU32 = writeU32;
function writeU64(value, buf, offset = 0) {
    buf.set([
        Number(value & 0xffn),
        Number((value >> 8n) & 0xffn),
        Number((value >> 16n) & 0xffn),
        Number((value >> 24n) & 0xffn),
        Number((value >> 32n) & 0xffn),
        Number((value >> 40n) & 0xffn),
        Number((value >> 48n) & 0xffn),
        Number((value >> 56n) & 0xffn),
    ], offset);
    return offset + 8;
}
exports.writeU64 = writeU64;
class WriteBool {
    constructor(value) {
        _WriteBool_value.set(this, void 0);
        __classPrivateFieldSet(this, _WriteBool_value, value, "f");
    }
    get length() {
        return 1;
    }
    write(buf, offset = 0) {
        buf.set([__classPrivateFieldGet(this, _WriteBool_value, "f") ? 1 : 0], offset);
    }
}
exports.WriteBool = WriteBool;
_WriteBool_value = new WeakMap();
class WriteU8 {
    constructor(value) {
        _WriteU8_value.set(this, void 0);
        __classPrivateFieldSet(this, _WriteU8_value, value, "f");
    }
    get length() {
        return 1;
    }
    write(buf, offset = 0) {
        writeU8(__classPrivateFieldGet(this, _WriteU8_value, "f"), buf, offset);
    }
}
exports.WriteU8 = WriteU8;
_WriteU8_value = new WeakMap();
class WriteU16 {
    constructor(value) {
        _WriteU16_value.set(this, void 0);
        __classPrivateFieldSet(this, _WriteU16_value, value, "f");
    }
    get length() {
        return 2;
    }
    write(buf, offset = 0) {
        writeU16(__classPrivateFieldGet(this, _WriteU16_value, "f"), buf, offset);
    }
}
exports.WriteU16 = WriteU16;
_WriteU16_value = new WeakMap();
class WriteU32 {
    constructor(value) {
        _WriteU32_value.set(this, void 0);
        __classPrivateFieldSet(this, _WriteU32_value, value, "f");
    }
    get length() {
        return 4;
    }
    write(buf, offset = 0) {
        writeU32(__classPrivateFieldGet(this, _WriteU32_value, "f"), buf, offset);
    }
}
exports.WriteU32 = WriteU32;
_WriteU32_value = new WeakMap();
class WriteU64 {
    constructor(value) {
        _WriteU64_value.set(this, void 0);
        __classPrivateFieldSet(this, _WriteU64_value, value, "f");
    }
    get length() {
        return 8;
    }
    write(buf, offset = 0) {
        writeU64(__classPrivateFieldGet(this, _WriteU64_value, "f"), buf, offset);
    }
}
exports.WriteU64 = WriteU64;
_WriteU64_value = new WeakMap();
class WriteUint8Array {
    constructor(value) {
        _WriteUint8Array_value.set(this, void 0);
        __classPrivateFieldSet(this, _WriteUint8Array_value, value, "f");
    }
    get length() {
        return __classPrivateFieldGet(this, _WriteUint8Array_value, "f").length;
    }
    write(buf, offset = 0) {
        buf.set(__classPrivateFieldGet(this, _WriteUint8Array_value, "f"), offset);
    }
}
exports.WriteUint8Array = WriteUint8Array;
_WriteUint8Array_value = new WeakMap();
class WriteString {
    constructor(value) {
        _WriteString_value.set(this, void 0);
        _WriteString_length.set(this, void 0);
        __classPrivateFieldSet(this, _WriteString_value, textEncoder.encode(value), "f");
        __classPrivateFieldSet(this, _WriteString_length, __classPrivateFieldGet(this, _WriteString_value, "f").length + 4, "f");
    }
    get length() {
        return __classPrivateFieldGet(this, _WriteString_length, "f");
    }
    write(buf, offset = 0) {
        // Write length as U32
        offset = writeU32(__classPrivateFieldGet(this, _WriteString_value, "f").length, buf, offset);
        // Write bytes
        buf.set(__classPrivateFieldGet(this, _WriteString_value, "f"), offset);
    }
}
exports.WriteString = WriteString;
_WriteString_value = new WeakMap(), _WriteString_length = new WeakMap();
class WriteExtended {
    constructor(value, size, writer) {
        _WriteExtended_value.set(this, void 0);
        _WriteExtended_length.set(this, void 0);
        _WriteExtended_writer.set(this, void 0);
        __classPrivateFieldSet(this, _WriteExtended_value, value, "f");
        __classPrivateFieldSet(this, _WriteExtended_writer, writer, "f");
        __classPrivateFieldSet(this, _WriteExtended_length, size, "f");
    }
    get length() {
        return __classPrivateFieldGet(this, _WriteExtended_length, "f");
    }
    write(buf, offset = 0) {
        __classPrivateFieldGet(this, _WriteExtended_writer, "f").write(__classPrivateFieldGet(this, _WriteExtended_value, "f"), buf, offset);
    }
}
exports.WriteExtended = WriteExtended;
_WriteExtended_value = new WeakMap(), _WriteExtended_length = new WeakMap(), _WriteExtended_writer = new WeakMap();
class BinaryWriter {
    constructor() {
        _BinaryWriter_writes.set(this, void 0);
        _BinaryWriter_length.set(this, void 0);
        __classPrivateFieldSet(this, _BinaryWriter_writes, [], "f");
        __classPrivateFieldSet(this, _BinaryWriter_length, 0, "f");
    }
    writeBool(value) {
        const w = new WriteBool(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeU8(value) {
        const w = new WriteU8(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeU16(value) {
        const w = new WriteU16(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeU32(value) {
        const w = new WriteU32(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeU64(value) {
        const w = new WriteU64(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeU128() {
        throw new Error('Not implemented yet!');
    }
    writeI8() {
        throw new Error('Not implemented yet!');
    }
    writeI16() {
        throw new Error('Not implemented yet!');
    }
    writeI32() {
        throw new Error('Not implemented yet!');
    }
    writeI64() {
        throw new Error('Not implemented yet!');
    }
    writeI128() {
        throw new Error('Not implemented yet!');
    }
    writeString(value) {
        const w = new WriteString(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeByteArray(value) {
        const w = new WriteUint8Array(value);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    writeF32() {
        throw new Error('Not implemented yet!');
    }
    writeF64() {
        throw new Error('Not implemented yet!');
    }
    writeExtended(value, options) {
        const w = new WriteExtended(value, options.size, options.writer);
        __classPrivateFieldSet(this, _BinaryWriter_length, __classPrivateFieldGet(this, _BinaryWriter_length, "f") + w.length, "f");
        __classPrivateFieldGet(this, _BinaryWriter_writes, "f").push(w);
    }
    toArray() {
        let buf = new Uint8Array(__classPrivateFieldGet(this, _BinaryWriter_length, "f"));
        let offset = 0;
        for (const w of __classPrivateFieldGet(this, _BinaryWriter_writes, "f")) {
            w.write(buf, offset);
            offset += w.length;
        }
        return buf;
    }
}
exports.BinaryWriter = BinaryWriter;
_BinaryWriter_writes = new WeakMap(), _BinaryWriter_length = new WeakMap();
//# sourceMappingURL=writer.js.map