export function invalidByteArrayLength(path, expected, actual) {
    throw new Error(`Borsh: Invalid byte array length at: ${path.join(',')}, expected: ${expected}, actual: ${actual}`);
}
export function unexpectedFieldSchema(path, expected, actual) {
    throw new Error(`Borsh: Found an unexpected schema at: ${path.join(',')}, expected: ${expected}, actual: ${actual}`);
}
export function extendedWriterNotFound(path) {
    throw new Error(`Borsh: Extended writer not found at: ${path.join(',')}`);
}
export function extendedReaderNotFound(path) {
    throw new Error(`Borsh: Extended reader not found at: ${path.join(',')}`);
}
export function noSuperClassForVariant(cls) {
    throw new Error(`Borsh: No super class available for class ${cls} which is decorated as variant`);
}
export function invalidEnumField(path) {
    throw new Error(`Borsh: Invalid enum field type at: ${path.join(',')}`);
}
//# sourceMappingURL=errors.js.map