import { ArrayFieldType, FieldType, OptionFieldType, StructFieldType, ExtendOptions, ExtendFieldType, Ctor, EnumFieldType, EnumClass, MapFieldType } from './types';
export declare function field(fieldType: FieldType): (target: any, key: PropertyKey) => void;
export declare function variant(variant: number): <T>(target: Ctor<T>) => void;
export declare function extend<T>(options: ExtendOptions<T>): ExtendFieldType<T>;
export declare function array(elementType: FieldType): ArrayFieldType;
export declare function map(keyType: FieldType, valueType: FieldType): MapFieldType;
export declare function option(innerType: FieldType): OptionFieldType;
export declare function struct<T>(ctor: Ctor<T>): StructFieldType<T>;
export declare function enums(enumClass: Function): EnumFieldType;
export declare function serialize(obj: any): Uint8Array;
export declare function deserialize<T>(enumClass: EnumClass<T>, data: Uint8Array): T;
export declare function deserialize<T>(ctor: Ctor<T>, data: Uint8Array): T;
export * from './types';
//# sourceMappingURL=index.d.ts.map